'------------------------------------------------------------------------------
' DCF77-Uhr mit LED-Display, abgewandelt aus AN181 fr TN20130831-2
' mit ATMega48 @8MHz, kompilierbar mit der Demoversion von BASCOM
' Fusebits: Low = F7h, High = DFh, Lock,Ext = FFh
'
' Version 1.20: 12/11/2014 - (c) T. Neveling, 2836 Byte, 69% Flash
'------------------------------------------------------------------------------

$regfile = "m48def.dat"
$crystal = 8000000

Config Dcf77 = Pinc.0 , Inverted = 1 , Timer = 1 , Debug = 0 , Check = 1 , Gosub = Sectic
Config Date = Dmy , Separator = .

Config Portb = Output                                       'Digits 0 - 5 (gem. Anode)
Config Portd = Output                                       'Segment-Ausgnge: A-G, DP
Dezimalpunkt Alias Portd.7                                  'wird gesondert behandelt
Ddrc = &B11111110                                           '1 Ausgang, 0 Eingang
Portc = &B00000001                                          'Pull-up-R am Eingang C0

Dim Bday As Byte , Bmonth As Byte , Byear As Byte
Dim Bsec As Byte , Bmin As Byte , Bhour As Byte
Dim Digitcnt As Byte
Dim Bcdzahl As Byte
Dim Z(6) As Byte

Enable Interrupts                                           'Timer 1 hat 1s Interrupt aus DCF77-Modul

Do                                                          'Main-Loop zum Multiplexen der Displays

 Portb = 0                                                  'Alle Digits (Anoden) aus
 Portd = 1                                                  'Alle Segmente (Kathoden) aus

 Incr Digitcnt                                              'alle 2ms wird nur ein Digit ausgegeben
 If Digitcnt = 6 Then Digitcnt = 0                          'bestimmt das auszugebende Digit (1 bis 6)
 Bcdzahl = Z(digitcnt + 1)                                  'Zahlenwert fr das gewhlte Digit

 Select Case Bcdzahl
    Case 1 : Portd = &HF9                                   'zugehrige Segmentmuster 1..9
    Case 2 : Portd = &HA4
    Case 3 : Portd = &HB0
    Case 4 : Portd = &H99
    Case 5 : Portd = &H92
    Case 6 : Portd = &H82
    Case 7 : Portd = &HD8                                   '7 mit Haken links oben
    Case 8 : Portd = &H80
    Case 9 : Portd = &H90
    Case 10 : Portd = &HC8                                  'M
    Case 11 : Portd = &HA3                                  'o
    Case 12 : Portd = &HA1                                  'd
    Case 13 : Portd = &HEF                                  'i
    Case 14 : Portd = &H8E                                  'F
    Case 15 : Portd = &HAF                                  'r
    Case 16 : Portd = &H88                                  'A
    Case 17 : Portd = &H83                                  'b
    Case 18 : Portd = &HBF                                  '- (MEZ)
    Case 19 : Portd = &HFE                                  'nur Segment A (Sommerzeit)
    Case 20 : Portd = &HFF                                  'dunkel
    Case 0 And Digitcnt = 5 : Portd = &B11111111            'Nullstellenunterdrckung  bei Digit5
    Case 0 And Digitcnt < 5 : Portd = &HC0                  'bei allen anderen Digits: Null anzeigen
 End Select
 If Digitcnt = 0 Then Dezimalpunkt = Pinc.0                 'Dezimalpunkt ganz rechts = Empfngeroutput

 If Bsec > 29 And Bsec < 32 Then                            'in Sek 30, 31 Punkte fr Datumsanzeige
   If Digitcnt = 2 Or Digitcnt = 4 Then
      Dezimalpunkt = 0
   End If
 End If

 Portb.digitcnt = 1                                         'gewhltes Digit einschalten

 Waitms 2                                                   'Multiplex-Pause

Loop                                                        'Endlosschleife

Sectic:
'Aufruf 1x pro Sekunde von der DCF77-Library via Timer1: bergibt Strings Time$ und Date$
'-----------------------------------------------------------------------------------------
'Zeitstring in 3 einzelne Byte-Variablen Bsec, Bmin, Bhour gem Deklarationsreihenfolge bernehmen
  Bsec = Time(time$)
'Datestring in 3 einzelne Byte-Variablen Bday, Bmonth, Byear gem Deklarationsreihenfolge bernehmen
  Bday = Date(date$)

Select Case Bsec
   Case 30 To 31 : Bcdzahl = Makebcd(byear)                 'Datum ausgeben
                    Z(1) = Bcdzahl And &B0000_1111
                    Shift Bcdzahl , Right , 4
                    Z(2) = Bcdzahl And &B0000_1111
                    Bcdzahl = Makebcd(bmonth)
                    Z(3) = Bcdzahl And &B0000_1111
                    Shift Bcdzahl , Right , 4
                    Z(4) = Bcdzahl And &B0000_1111
                    Bcdzahl = Makebcd(bday)
                    Z(5) = Bcdzahl And &B0000_1111
                    Shift Bcdzahl , Right , 4
                    Z(6) = Bcdzahl And &B0000_1111

   Case 32 To 33 : If Dcf_status.7 = 1 Then                 'Nur nach gltigem Empfang
                      Z(1) = 20                             'Digits 1,2,5 dunkel
                      Z(2) = 20
                      Z(5) = 20
                      If Dcf77timezone() = 1 Then Z(6) = 18 Else Z(6) = 19
                      Select Case Dayofweek()               'Wochentag ausgeben
                      Case 0 : Z(4) = 10                    'Mo
                                Z(3) = 11
                      Case 1 : Z(4) = 12                    'di
                                Z(3) = 13
                      Case 2 : Z(4) = 10                    'Mi
                                Z(3) = 13
                      Case 3 : Z(4) = 12                    'do
                                Z(3) = 11
                      Case 4 : Z(4) = 14                    'Fr
                                Z(3) = 15
                      Case 5 : Z(4) = 5                     'SA
                                Z(3) = 16
                      Case 6 : Z(4) = 5                     'So
                                Z(3) = 11
                      End Select
                    Else                                    'vorher: Firmwarevers. ausgeben
                      Z(6) = 20                             'blank
                      Z(5) = 17                             'b = BASCOM
                      Z(4) = 14                             'F = Firmware
                      Z(3) = 1
                      Z(2) = 2
                      Z(1) = 0
                    End If

   Case Else : Bcdzahl = Makebcd(bsec)                      'sonst Zeit ausgeben
                Z(1) = Bcdzahl And &B0000_1111
                Shift Bcdzahl , Right , 4
                Z(2) = Bcdzahl And &B0000_1111
                Bcdzahl = Makebcd(bmin)
                Z(3) = Bcdzahl And &B0000_1111
                Shift Bcdzahl , Right , 4
                Z(4) = Bcdzahl And &B0000_1111
                Bcdzahl = Makebcd(bhour)
                Z(5) = Bcdzahl And &B0000_1111
                Shift Bcdzahl , Right , 4
                Z(6) = Bcdzahl And &B0000_1111
   End Select
Return

End